﻿/* Author: Sebastian Dusch (http://die-rooter.de/ITworks)
* Date: 26-Nov-2009
* The code you have here is licensed as "Creative Commons NC-BY-SA"
* Please contact me at neiky(at)premiumpixel.com if you want to use this code
* in commercial projects.
* This file is licensed under Creative Commons Namensnennung-Keine kommerzielle Nutzung-Weitergabe unter gleichen Bedingungen 3.0 Deutschland license.
*/ 
using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
using System.Windows.Controls.Extensions.ExtensionMethods;

namespace System.Windows.Controls.Extensions
{
    public class SharedSizeManager
    {
        private static SharedSizeManager instance = null;
        public static SharedSizeManager Instance
        {
            get
            {
                if (SharedSizeManager.instance == null)
                {
                    SharedSizeManager.instance = new SharedSizeManager();
                }
                return SharedSizeManager.instance;
            }
        }

        private List<SharedSizeScope> Scopes { get; set; }

        private SharedSizeManager() 
        {
            this.Scopes = new List<SharedSizeScope>();
        }

        internal void AddRow(RowDefinition row)
        {
            
        }

        internal void AddColumn(ColumnDefinition column)
        {
            
        }

        internal void AddScope(FrameworkElement element)
        {
            element.Loaded += new RoutedEventHandler(Scope_Loaded);
        }


        void Scope_Loaded(object sender, RoutedEventArgs e)
        {
            FrameworkElement element = sender as FrameworkElement;

            if (element != null)
            {
                /* Find all Grid that has SharedSizeGroup tagged Rows 
                 * oder Columns until we find another scope*/
                List<SharedSizeGrid> grids = element.FindGridsInScope();
                SharedSizeScope scope = new SharedSizeScope(element);
                scope.Children.AddRange(grids);

                this.Scopes.Add(scope);
            }
            else
            {
                throw new ArgumentException("This method is only supposed to work with FrameworkElements", "sender");
            }
        }
    }
}
